## halide 13.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.20)
project(Halide
        VERSION 13.0.3
        DESCRIPTION "Halide compiler and libraries"
        HOMEPAGE_URL "https://halide-lang.org")

enable_testing()

##
# Set up project-wide properties
##

# Make our custom helpers available throughout the project via include().
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
include(HalideGeneratorHelpers)
include(MakeShellPath)
include(CMakeDependentOption)

# Build Halide as a shared lib by default, but still honor command-line settings.
option(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Warn if the user did not set a build type and is using a single-configuration generator.
get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if (NOT IS_MULTI_CONFIG AND NOT CMAKE_BUILD_TYPE)
    message(WARNING "Single-configuration generators require CMAKE_BUILD_TYPE to be set.")
endif ()

# Windows has file name length restrictions and lacks an RPATH mechanism.
# We work around this by setting a path max and putting all exes / dlls in
# the same output directory.
if (CMAKE_SYSTEM_NAME MATCHES "Windows")
    set(CMAKE_OBJECT_PATH_MAX 260)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")

    message(STATUS "Windows: setting CMAKE_OBJECT_PATH_MAX to ${CMAKE_OBJECT_PATH_MAX}")
endif ()

# Export all symbols on Windows to match GCC/Clang behavior on Linux/macOS
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# Require standard C++17
if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(CMAKE_CXX_EXTENSIONS OFF)
elseif(CMAKE_CXX_STANDARD LESS 17)
    message(FATAL_ERROR "Halide requires C++17 or newer")
endif()

# Build Halide with ccache if the package is present
option(Halide_CCACHE_BUILD "Set to ON for a ccache enabled build" OFF)
mark_as_advanced(Halide_CCACHE_BUILD)
if (Halide_CCACHE_BUILD)
    find_program(CCACHE_PROGRAM ccache)
    if (CCACHE_PROGRAM)
        # TODO: ccache recommends setting CCACHE_SLOPPINESS=pch_defines,time_macros to
        # enable precompiled header caching. Our timing found it slightly faster with
        # just CCACHE_SLOPPINESS=pch_defines, so that's what we're using. Maybe revisit
        # if issues occur (but we don't use any of the time macros so should be irrelevant).
        set(Halide_CCACHE_PARAMS CCACHE_CPP2=yes CCACHE_HASHDIR=yes CCACHE_SLOPPINESS=pch_defines
            CACHE STRING "Parameters to pass through to ccache")
        mark_as_advanced(Halide_CCACHE_PARAMS)
        set(CMAKE_C_COMPILER_LAUNCHER ${CMAKE_COMMAND} -E env ${Halide_CCACHE_PARAMS} ${CCACHE_PROGRAM})
        set(CMAKE_CXX_COMPILER_LAUNCHER ${CMAKE_COMMAND} -E env ${Halide_CCACHE_PARAMS} ${CCACHE_PROGRAM})
        message(STATUS "Enabling ccache usage for building.")
    else ()
        message(FATAL_ERROR "Unable to find the program ccache. Set Halide_CCACHE_BUILD to OFF")
    endif ()
endif ()

##
# Import dependencies
##

add_subdirectory(dependencies)

##
# Add source directories
##

add_subdirectory(src)
add_subdirectory(tools)

##
# Add tests, tutorials, etc. if we're not being imported into another CMake project.
##

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    option(WITH_TESTS "Build tests" ON)
    if (WITH_TESTS)
        message(STATUS "Building tests enabled")
        add_subdirectory(test)
    else ()
        message(STATUS "Building tests disabled")
    endif ()

    option(WITH_PYTHON_BINDINGS "Build Python bindings" ON)
    if (WITH_PYTHON_BINDINGS)
        if (Halide_ENABLE_RTTI AND Halide_ENABLE_EXCEPTIONS)
            message(STATUS "Building Python bindings enabled")
            add_subdirectory(python_bindings)
        else ()
            if (NOT Halide_ENABLE_RTTI)
                message(WARNING "Building Python bindings disabled: must compile with RTTI")
            endif ()
            if (NOT Halide_ENABLE_EXCEPTIONS)
                message(WARNING "Building Python bindings disabled: must compile with exceptions")
            endif ()
            set(WITH_PYTHON_BINDINGS OFF CACHE BOOL "Build Python bindings" FORCE)
        endif ()
    else ()
        message(STATUS "Building Python bindings disabled")
    endif ()

    option(WITH_TUTORIALS "Build tutorials" ON)
    if (WITH_TUTORIALS)
        message(STATUS "Building tutorials enabled")
        add_subdirectory(tutorial)
    else ()
        message(STATUS "Building tutorials disabled")
    endif ()

    option(WITH_DOCS "Build documentation" OFF)
    if (WITH_DOCS)
        message(STATUS "Building docs enabled")
        add_subdirectory(doc)
    else ()
        message(STATUS "Building docs disabled")
    endif ()

    option(WITH_UTILS "Build utils" ON)
    if (WITH_UTILS)
        message(STATUS "Building utils enabled")
        add_subdirectory(util)
    else ()
        message(STATUS "Building utils disabled")
    endif ()

    add_subdirectory(packaging)

    add_custom_target(distrib
                      COMMAND ${CMAKE_COMMAND} -E echo "\\'distrib\\' is not available under CMake. Use \\'package\\' instead.")

    if (TARGET clang-format AND NOT WIN32)
        add_custom_target(format COMMAND
                          find
                          "${Halide_SOURCE_DIR}/apps"
                          "${Halide_SOURCE_DIR}/src"
                          "${Halide_SOURCE_DIR}/tools"
                          "${Halide_SOURCE_DIR}/test"
                          "${Halide_SOURCE_DIR}/util"
                          "${Halide_SOURCE_DIR}/python_bindings"
                          -name *.cpp -o -name *.h -o -name *.c |
                          xargs $<TARGET_FILE:clang-format> -i -style=file)
    endif ()
endif ()

=== apps/fft/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(fft)

enable_testing()

# Set up language settings
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

# Find Halide
find_package(Halide REQUIRED)

# Generator
add_executable(fft.generator fft_generator.cpp fft.cpp)
target_link_libraries(fft.generator PRIVATE Halide::Generator)

# Filters
add_halide_library(fft_forward_r2c FROM fft.generator
                   GENERATOR fft
                   PARAMS direction=samples_to_frequency size0=16 size1=16 gain=0.00390625 input_number_type=real output_number_type=complex)
add_halide_library(fft_inverse_c2r FROM fft.generator
                   GENERATOR fft
                   PARAMS direction=frequency_to_samples size0=16 size1=16 input_number_type=complex output_number_type=real)
add_halide_library(fft_forward_c2c FROM fft.generator
                   GENERATOR fft
                   PARAMS direction=samples_to_frequency size0=16 size1=16 gain=0.00390625 input_number_type=complex output_number_type=complex)
add_halide_library(fft_inverse_c2c FROM fft.generator
                   GENERATOR fft
                   PARAMS direction=frequency_to_samples size0=16 size1=16 input_number_type=complex output_number_type=complex)

# Main executable
add_executable(fft_aot_test fft_aot_test.cpp)
target_link_libraries(fft_aot_test PRIVATE Halide::ImageIO fft_forward_r2c fft_inverse_c2r fft_forward_c2c fft_inverse_c2c)

# Benchmarking executable
add_executable(bench_fft main.cpp fft.cpp)
target_link_libraries(bench_fft PRIVATE Halide::Halide Halide::Tools)

# Test that the app actually works!
add_test(NAME fft_aot_test COMMAND fft_aot_test)
set_tests_properties(fft_aot_test PROPERTIES
                     LABELS fft
                     PASS_REGULAR_EXPRESSION "Success!"
                     SKIP_REGULAR_EXPRESSION "\\[SKIP\\]")

foreach (i IN ITEMS 8 12 16 24 32 48)
    add_test(NAME bench${i}x${i} COMMAND bench_fft ${i} ${i} "${CMAKE_CURRENT_BINARY_DIR}")
    set_tests_properties(bench${i}x${i} 
                         PROPERTIES
                         LABELS fft
                         ENVIRONMENT "PATH=$<SHELL_PATH:$<TARGET_FILE_DIR:Halide::Halide>>")
endforeach ()

=== apps/nl_means/Makefile ===
include ../support/Makefile.inc

.PHONY: build clean test

build: $(BIN)/$(HL_TARGET)/process

$(GENERATOR_BIN)/nl_means.generator: nl_means_generator.cpp $(GENERATOR_DEPS)
	@mkdir -p $(@D)
	$(CXX) $(CXXFLAGS) $(filter %.cpp,$^) -o $@ $(LIBHALIDE_LDFLAGS)

$(BIN)/%/nl_means.a: $(GENERATOR_BIN)/nl_means.generator
	@mkdir -p $(@D)
	$^ -g nl_means -e $(GENERATOR_OUTPUTS) -o $(@D) -f nl_means target=$* auto_schedule=false

$(BIN)/%/nl_means_auto_schedule.a: $(GENERATOR_BIN)/nl_means.generator
	@mkdir -p $(@D)
	$^ -g nl_means -e $(GENERATOR_OUTPUTS) -o $(@D) -f nl_means_auto_schedule target=$*-no_runtime auto_schedule=true

$(BIN)/%/process: process.cpp $(BIN)/%/nl_means.a $(BIN)/%/nl_means_auto_schedule.a
	@mkdir -p $(@D)
	$(CXX) $(CXXFLAGS) -I$(BIN)/$* -Wall $^ -o $@ $(LDFLAGS) $(IMAGE_IO_FLAGS) $(CUDA_LDFLAGS) $(OPENCL_LDFLAGS)

$(BIN)/%/out.png: $(BIN)/%/process
	@mkdir -p $(@D)
	$< $(IMAGES)/rgb.png 7 7 0.12 10 $@

clean:
	rm -rf $(BIN)

test: $(BIN)/$(HL_TARGET)/out.png

=== apps/resize/Makefile ===
include ../support/Makefile.inc

VARIANTS = \
box_float32_up box_float32_down \
box_uint16_up box_uint16_down \
box_uint8_up box_uint8_down \
linear_float32_up linear_float32_down \
linear_uint16_up linear_uint16_down \
linear_uint8_up linear_uint8_down \
cubic_float32_up cubic_float32_down \
cubic_uint16_up cubic_uint16_down \
cubic_uint8_up cubic_uint8_down \
lanczos_float32_up lanczos_float32_down \
lanczos_uint16_up lanczos_uint16_down \
lanczos_uint8_up lanczos_uint8_down

LIBRARIES = $(foreach V,$(VARIANTS),$(BIN)/%/resize_$(V).a)
OUTPUTS = $(foreach V,$(VARIANTS),$(BIN)/$(HL_TARGET)/out_$(V).png)

.PHONY: build clean test

build: $(BIN)/$(HL_TARGET)/resize

test: $(OUTPUTS)

$(GENERATOR_BIN)/resize.generator: resize_generator.cpp $(GENERATOR_DEPS)
	@mkdir -p $(@D)
	$(CXX) $(CXXFLAGS) $(filter %.cpp,$^) -o $@ $(LIBHALIDE_LDFLAGS)

# Can't have multiple wildcards in Make, so we'll use a macro
# to stamp out all the rules we need
define GEN_RULE
$$(BIN)/%/resize_$(1).a: $$(GENERATOR_BIN)/resize.generator
	@mkdir -p $$(@D)
	$$^ -g resize -o $$(@D) -f resize_$(1) \
	target=$$*-no_runtime \
	interpolation_type=$$$$(echo $(1) | cut -d_ -f1) \
	input.type=$$$$(echo $(1) | cut -d_ -f2) \
	upsample=$$$$(echo $(1) | cut -d_ -f3 | sed 's/up/true/;s/down/false/')
endef

$(foreach V,$(VARIANTS),$(eval $(call GEN_RULE,$(V))))

$(BIN)/%/runtime.a: $(GENERATOR_BIN)/resize.generator
	@mkdir -p $(@D)
	$^ -r runtime -o $(@D) target=$*

$(BIN)/%/resize: resize.cpp $(LIBRARIES) $(BIN)/%/runtime.a
	@mkdir -p $(@D)
	$(CXX) $(CXXFLAGS) -I $(BIN)/$* $^ -o $@ $(IMAGE_IO_FLAGS) $(LDFLAGS)

# Make the small input used to test upsampling with our highest-quality downsampling method
$(BIN)/%/rgb_small.png: $(BIN)/%/resize
	@mkdir -p $(@D)
	@$(BIN)/$(HL_TARGET)/resize \
	$(IMAGES)/rgb.png \
	$(BIN)/$(HL_TARGET)/rgb_small.png \
	-i lanczos \
	-t float32 \
	-f 0.125

$(BIN)/$(HL_TARGET)/out_%_up.png: $(BIN)/$(HL_TARGET)/resize $(BIN)/$(HL_TARGET)/rgb_small.png
	@mkdir -p $(@D)
	@$(BIN)/$(HL_TARGET)/resize \
	$(BIN)/$(HL_TARGET)/rgb_small.png \
	$(BIN)/$(HL_TARGET)/out_$*_up.png \
	-i $$(echo $* | cut -d_ -f1) \
	-t $$(echo $* | cut -d_ -f2) \
	-f 4.0

$(BIN)/$(HL_TARGET)/out_%_down.png: $(BIN)/$(HL_TARGET)/resize
	@mkdir -p $(@D)
	@$(BIN)/$(HL_TARGET)/resize \
	$(IMAGES)/rgb.png \
	$(BIN)/$(HL_TARGET)/out_$*_down.png \
	-i $$(echo $* | cut -d_ -f1) \
	-t $$(echo $* | cut -d_ -f2) \
	-f 0.5

clean:
	rm -rf $(BIN)

../../bin/HalideTraceViz: ../../util/HalideTraceViz.cpp
	$(MAKE) -C ../../ bin/HalideTraceViz

.SECONDARY:

$(BIN)/$(HL_TARGET)/viz_auto_%.mp4: $(BIN)/$(HL_TARGET)-trace_all/resize ../support/viz_auto.sh ../../bin/HalideTraceViz
	@mkdir -p $(@D)
	HL_AVCONV=$(HL_AVCONV) bash ../support/viz_auto.sh \
		"$(BIN)/$(HL_TARGET)-trace_all/resize $(IMAGES)/rgb_small.png /tmp/$*.png -p 0 -b 1 -i $* -t float32 -f 0.5" \
		"../../bin/HalideTraceViz --timestep 1000" \
		$@

viz_auto_%: $(BIN)/$(HL_TARGET)/viz_auto_%.mp4
	$(HL_VIDEOPLAYER) $^

=== test/correctness/CMakeLists.txt ===
tests(GROUPS correctness_multi_gpu
      SOURCES
      gpu_multi_device.cpp
      )

tests(GROUPS correctness
      SOURCES
      align_bounds.cpp
      argmax.cpp
      assertion_failure_in_parallel_for.cpp
      async.cpp
      async_copy_chain.cpp
      async_device_copy.cpp
      atomic_tuples.cpp
      atomics.cpp
      autodiff.cpp
      bad_likely.cpp
      bit_counting.cpp
      bitwise_ops.cpp
      bool_compute_root_vectorize.cpp
      bound.cpp
      bound_small_allocations.cpp
      boundary_conditions.cpp
      bounds.cpp
      bounds_inference.cpp
      bounds_inference_chunk.cpp
      bounds_inference_complex.cpp
      bounds_inference_outer_split.cpp
      bounds_of_abs.cpp
      bounds_of_cast.cpp
      bounds_of_func.cpp
      bounds_of_monotonic_math.cpp
      bounds_of_multiply.cpp
      bounds_of_split.cpp
      bounds_query.cpp
      buffer_t.cpp
      c_function.cpp
      cascaded_filters.cpp
      cast.cpp
      cast_handle.cpp
      chunk.cpp
      chunk_sharing.cpp
      circular_reference_leak.cpp
      code_explosion.cpp
      compare_vars.cpp
      compile_to.cpp
      compile_to_bitcode.cpp
      compile_to_lowered_stmt.cpp
      compile_to_multitarget.cpp
      compute_at_reordered_update_stage.cpp
      compute_at_split_rvar.cpp
      compute_inside_guard.cpp
      compute_outermost.cpp
      compute_with.cpp
      compute_with_in.cpp
      compute_with_inlined.cpp
      computed_index.cpp
      concat.cpp
      constant_expr.cpp
      constant_type.cpp
      constraints.cpp
      convolution.cpp
      convolution_multiple_kernels.cpp
      cross_compilation.cpp
      cuda_8_bit_dot_product.cpp
      custom_allocator.cpp
      custom_auto_scheduler.cpp
      custom_error_reporter.cpp
      custom_lowering_pass.cpp
      dead_realization_in_specialization.cpp
      debug_to_file.cpp
      debug_to_file_multiple_outputs.cpp
      debug_to_file_reorder.cpp
      deferred_loop_level.cpp
      deinterleave4.cpp
      device_buffer_copy.cpp
      device_copy_at_inner_loop.cpp
      device_crop.cpp
      device_slice.cpp
      dilate3x3.cpp
      div_by_zero.cpp
      dynamic_allocation_in_gpu_kernel.cpp
      dynamic_reduction_bounds.cpp
      embed_bitcode.cpp
      erf.cpp
      exception.cpp
      explicit_inline_reductions.cpp
      extern_bounds_inference.cpp
      extern_consumer.cpp
      extern_consumer_tiled.cpp
      extern_error.cpp
      extern_output_expansion.cpp
      extern_partial.cpp
      extern_producer.cpp
      extern_reorder_storage.cpp
      extern_sort.cpp
      extern_stage.cpp
      extern_stage_on_device.cpp
      external_code.cpp
      failed_unroll.cpp
      fast_trigonometric.cpp
      fibonacci.cpp
      fit_function.cpp
      float16_t.cpp
      float16_t_comparison.cpp
      float16_t_constants.cpp
      float16_t_image_type.cpp
      float16_t_neon_op_check.cpp
      for_each_element.cpp
      force_onto_stack.cpp
      func_clone.cpp
      func_lifetime.cpp
      func_lifetime_2.cpp
      func_wrapper.cpp
      fuse.cpp
      fuse_gpu_threads.cpp
      fused_where_inner_extent_is_zero.cpp
      fuzz_bounds.cpp
      fuzz_cse.cpp
      fuzz_float_stores.cpp
      fuzz_simplify.cpp
      gameoflife.cpp
      gather.cpp
      gpu_allocation_cache.cpp
      gpu_arg_types.cpp
      gpu_assertion_in_kernel.cpp
      gpu_bounds_inference_failure.cpp
      gpu_condition_lifting.cpp
      gpu_cpu_simultaneous_read.cpp
      gpu_data_flows.cpp
      gpu_different_blocks_threads_dimensions.cpp
      gpu_dynamic_shared.cpp
      gpu_free_sync.cpp
      gpu_give_input_buffers_device_allocations.cpp
      gpu_jit_explicit_copy_to_device.cpp
      gpu_large_alloc.cpp
      gpu_many_kernels.cpp
      gpu_mixed_dimensionality.cpp
      gpu_mixed_shared_mem_types.cpp
      gpu_multi_kernel.cpp
      gpu_non_contiguous_copy.cpp
      gpu_non_monotonic_shared_mem_size.cpp
      gpu_object_lifetime_1.cpp
      gpu_object_lifetime_2.cpp
      gpu_object_lifetime_3.cpp
      gpu_param_allocation.cpp
      gpu_reuse_shared_memory.cpp
      gpu_specialize.cpp
      gpu_store_in_register_with_no_lanes_loop.cpp
      gpu_sum_scan.cpp
      gpu_texture.cpp
      gpu_thread_barrier.cpp
      gpu_transpose.cpp
      gpu_vectorize.cpp
      gpu_vectorized_shared_memory.cpp
      growing_stack.cpp
      half_native_interleave.cpp
      halide_buffer.cpp
      handle.cpp
      heap_cleanup.cpp
      hello_gpu.cpp
      hexagon_scatter.cpp
      histogram.cpp
      histogram_equalize.cpp
      hoist_loop_invariant_if_statements.cpp
      host_alignment.cpp
      image_io.cpp
      image_of_lists.cpp
      image_wrapper.cpp
      implicit_args.cpp
      implicit_args_tests.cpp
      in_place.cpp
      indexing_access_undef.cpp
      infer_arguments.cpp
      inline_reduction.cpp
      inlined_generator.cpp
      input_image_bounds_check.cpp
      input_larger_than_two_gigs.cpp
      integer_powers.cpp
      interleave.cpp
      interleave_rgb.cpp
      interleave_x.cpp
      interpreter.cpp
      interval.cpp
      intrinsics.cpp
      introspection.cpp
      inverse.cpp
      isnan.cpp
      issue_3926.cpp
      iterate_over_circle.cpp
      lambda.cpp
      lazy_convolution.cpp
      leak_device_memory.cpp
      left_shift_negative.cpp
      legal_race_condition.cpp
      lerp.cpp
      let_in_rdom_bound.cpp
      likely.cpp
      load_library.cpp
      logical.cpp
      loop_invariant_extern_calls.cpp
      loop_level_generator_param.cpp
      lossless_cast.cpp
      lots_of_dimensions.cpp
      lots_of_loop_invariants.cpp
      make_struct.cpp
      many_dimensions.cpp
      many_small_extern_stages.cpp
      many_updates.cpp
      math.cpp
      median3x3.cpp
      memoize.cpp
      memoize_cloned.cpp
      min_extent.cpp
      mod.cpp
      mul_div_mod.cpp
      multi_output_pipeline_with_bad_sizes.cpp
      multi_pass_reduction.cpp
      multi_splits_with_diff_tail_strategies.cpp
      multi_way_select.cpp
      multipass_constraints.cpp
      multiple_outputs.cpp
      multiple_outputs_extern.cpp
      multiple_scatter.cpp
      mux.cpp
      named_updates.cpp
      nested_shiftinwards.cpp
      nested_tail_strategies.cpp
      newtons_method.cpp
      non_nesting_extern_bounds_query.cpp
      non_vector_aligned_embeded_buffer.cpp
      obscure_image_references.cpp
      oddly_sized_output.cpp
      out_constraint.cpp
      out_of_memory.cpp
      output_larger_than_two_gigs.cpp
      parallel.cpp
      parallel_alloc.cpp
      parallel_fork.cpp
      parallel_gpu_nested.cpp
      parallel_nested.cpp
      parallel_nested_1.cpp
      parallel_scatter.cpp
      parallel_reductions.cpp
      parallel_rvar.cpp
      param.cpp
      param_map.cpp
      parameter_constraints.cpp
      partial_application.cpp
      partial_realization.cpp
      partition_loops.cpp
      partition_loops_bug.cpp
      partition_max_filter.cpp
      pipeline_set_jit_externs_func.cpp
      plain_c_includes.c
      popc_clz_ctz_bounds.cpp
      predicated_store_load.cpp
      prefetch.cpp
      print.cpp
      print_loop_nest.cpp
      process_some_tiles.cpp
      pseudostack_shares_slots.cpp
      python_extension_gen.cpp
      random.cpp
      realize_larger_than_two_gigs.cpp
      realize_over_shifted_domain.cpp
      reduction_chain.cpp
      reduction_non_rectangular.cpp
      reduction_schedule.cpp
      register_shuffle.cpp
      reorder_rvars.cpp
      reorder_storage.cpp
      require.cpp
      reschedule.cpp
      reuse_stack_alloc.cpp
      rfactor.cpp
      round.cpp
      saturating_casts.cpp
      scatter.cpp
      set_custom_trace.cpp
      shadowed_bound.cpp
      shared_self_references.cpp
      shifted_image.cpp
      side_effects.cpp
      simd_op_check.cpp
      simd_op_check_hvx.cpp
      simplified_away_embedded_image.cpp
      simplify.cpp
      skip_stages.cpp
      skip_stages_external_array_functions.cpp
      skip_stages_memoize.cpp
      sliding_backwards.cpp
      sliding_over_guard_with_if.cpp
      sliding_reduction.cpp
      sliding_window.cpp
      sort_exprs.cpp
      specialize.cpp
      specialize_to_gpu.cpp
      split_by_non_factor.cpp
      split_fuse_rvar.cpp
      split_reuse_inner_name_bug.cpp
      split_store_compute.cpp
      stack_allocations.cpp
      stencil_chain_in_update_definitions.cpp
      stmt_to_html.cpp
      storage_folding.cpp
      store_in.cpp
      stream_compaction.cpp
      strict_float.cpp
      strict_float_bounds.cpp
      strided_load.cpp
      target.cpp
      thread_safety.cpp
      tracing.cpp
      tracing_bounds.cpp
      tracing_broadcast.cpp
      tracing_stack.cpp
      transitive_bounds.cpp
      trim_no_ops.cpp
      truncated_pyramid.cpp
      tuple_partial_update.cpp
      tuple_reduction.cpp
      tuple_select.cpp
      tuple_undef.cpp
      tuple_update_ops.cpp
      tuple_vector_reduce.cpp
      two_vector_args.cpp
      undef.cpp
      uninitialized_read.cpp
      unique_func_image.cpp
      unroll_dynamic_loop.cpp
      unroll_huge_mux.cpp
      unrolled_reduction.cpp
      unsafe_dedup_lets.cpp
      unsafe_promises.cpp
      unused_func.cpp
      update_chunk.cpp
      vector_bounds_inference.cpp
      vector_cast.cpp
      vector_extern.cpp
      vector_math.cpp
      vector_print_bug.cpp
      vector_reductions.cpp
      vector_tile.cpp
      vectorize_guard_with_if.cpp
      vectorize_mixed_widths.cpp
      vectorize_nested.cpp
      vectorize_varying_allocation_size.cpp
      vectorized_gpu_allocation.cpp
      vectorized_initialization.cpp
      vectorized_load_from_vectorized_allocation.cpp
      vectorized_reduction_bug.cpp
      widening_reduction.cpp
      )

# Make sure the test that needs image_io has it
target_link_libraries(correctness_image_io PRIVATE Halide::ImageIO)

# Tests which use external funcs need to enable exports.
set_target_properties(correctness_async
                      correctness_atomics
                      correctness_c_function
                      correctness_compute_at_split_rvar
                      correctness_concat
                      correctness_custom_lowering_pass
                      correctness_extern_bounds_inference
                      correctness_extern_consumer
                      correctness_extern_consumer_tiled
                      correctness_extern_error
                      correctness_extern_output_expansion
                      correctness_extern_partial
                      correctness_extern_producer
                      correctness_extern_reorder_storage
                      correctness_extern_sort
                      correctness_extern_stage
                      correctness_extern_stage_on_device
                      correctness_handle
                      correctness_image_of_lists
                      correctness_lazy_convolution
                      correctness_loop_invariant_extern_calls
                      correctness_make_struct
                      correctness_many_small_extern_stages
                      correctness_memoize
                      correctness_memoize_cloned
                      correctness_multiple_outputs_extern
                      correctness_non_nesting_extern_bounds_query
                      correctness_parallel_fork
                      correctness_pipeline_set_jit_externs_func
                      correctness_process_some_tiles
                      correctness_side_effects
                      correctness_skip_stages
                      correctness_skip_stages_external_array_functions
                      correctness_sliding_backwards
                      correctness_sliding_over_guard_with_if
                      correctness_sliding_reduction
                      correctness_sliding_window
                      correctness_storage_folding
                      PROPERTIES ENABLE_EXPORTS TRUE)

=== apps/hannk/halide/CMakeLists.txt ===

add_library(common_halide STATIC common_halide.cpp)
target_link_libraries(common_halide PRIVATE Halide::Halide)
target_include_directories(common_halide PUBLIC $<BUILD_INTERFACE:${hannk_SOURCE_DIR}>)

set(_HANNK_HALIDE_TARGETS "")

# Function to reduce boilerplate
function(_add_hannk_halide_library)
    set(options)
    set(oneValueArgs TARGET GENERATOR_NAME)
    set(multiValueArgs SRCS GENERATOR_ARGS GENERATOR_DEPS FEATURES)
    cmake_parse_arguments(args "" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

    add_executable(${args_TARGET}.generator ${args_SRCS})
    target_link_libraries(${args_TARGET}.generator PRIVATE ${args_GENERATOR_DEPS} common_halide Halide::Generator)
    target_include_directories(${args_TARGET}.generator PUBLIC $<BUILD_INTERFACE:${hannk_SOURCE_DIR}>)

    add_halide_library(${args_TARGET} FROM ${args_TARGET}.generator
                       NAMESPACE hannk
                       GENERATOR ${args_GENERATOR_NAME}
                       FEATURES large_buffers c_plus_plus_name_mangling ${args_FEATURES}
                       PARAMS ${args_GENERATOR_ARGS})

    set(_HANNK_HALIDE_TARGETS ${_HANNK_HALIDE_TARGETS} ${args_TARGET} PARENT_SCOPE)
endfunction()

_add_hannk_halide_library(
        TARGET add_uint8_uint8
        SRCS elementwise_generator.cpp
        FEATURES no_bounds_query
        GENERATOR_NAME Add
        GENERATOR_ARGS
        GENERATOR_DEPS elementwise_program)

_add_hannk_halide_library(
        TARGET average_pool_uint8
        SRCS pool_generator.cpp
        GENERATOR_NAME AveragePool
        GENERATOR_ARGS
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET conv_u8_u8_u8
        SRCS conv_generator.cpp
        GENERATOR_NAME Conv
        GENERATOR_ARGS output.type=uint8
        GENERATOR_DEPS)


_add_hannk_halide_library(
        TARGET conv_u8_u8_i16
        SRCS conv_generator.cpp
        GENERATOR_NAME Conv
        GENERATOR_ARGS output.type=int16
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET copy_uint8_uint8
        SRCS copy_generator.cpp
        FEATURES no_bounds_query
        GENERATOR_NAME Copy
        GENERATOR_ARGS input.type=uint8 output.type=uint8
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET depthwise_conv_uint8
        SRCS depthwise_conv_generator.cpp
        GENERATOR_NAME DepthwiseConv
        GENERATOR_ARGS inv_depth_multiplier=1
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET depthwise_conv_broadcast_uint8
        SRCS depthwise_conv_generator.cpp
        GENERATOR_NAME DepthwiseConv
        GENERATOR_ARGS inv_depth_multiplier=0
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET depthwise_conv_shallow_uint8
        SRCS depthwise_conv_generator.cpp
        GENERATOR_NAME DepthwiseConv
        GENERATOR_ARGS inv_depth_multiplier=1 shallow=true
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET fill_uint8
        SRCS fill_generator.cpp
        FEATURES no_bounds_query no_asserts
        GENERATOR_NAME Fill
        GENERATOR_ARGS
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET elementwise_5xuint8_1xuint8
        SRCS elementwise_generator.cpp
        FEATURES no_bounds_query
        GENERATOR_NAME Elementwise
        GENERATOR_ARGS inputs.size=5 inputs.type=uint8 output1_type=uint8
        GENERATOR_DEPS elementwise_program)

_add_hannk_halide_library(
        TARGET elementwise_5xint16_1xuint8int16
        SRCS elementwise_generator.cpp
        FEATURES no_bounds_query
        GENERATOR_NAME Elementwise
        GENERATOR_ARGS inputs.size=5 inputs.type=int16 output1_type=uint8 output2_type=int16
        GENERATOR_DEPS elementwise_program)

_add_hannk_halide_library(
        TARGET l2_normalization_uint8
        SRCS normalizations_generator.cpp
        FEATURES no_bounds_query
        GENERATOR_NAME L2Normalization
        GENERATOR_ARGS
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET max_pool_uint8
        SRCS pool_generator.cpp
        GENERATOR_NAME MaxPool
        GENERATOR_ARGS
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET mean_uint8
        SRCS reductions_generator.cpp
        GENERATOR_NAME Mean
        GENERATOR_ARGS
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET mul_uint8_uint8_uint8
        SRCS elementwise_generator.cpp
        FEATURES no_bounds_query
        GENERATOR_NAME Mul
        GENERATOR_ARGS
        GENERATOR_DEPS elementwise_program)

_add_hannk_halide_library(
        TARGET softmax_uint8
        SRCS normalizations_generator.cpp
        FEATURES no_bounds_query
        GENERATOR_NAME Softmax
        GENERATOR_ARGS
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET tile_conv_filter_uint8
        SRCS conv_generator.cpp
        GENERATOR_NAME TileConvFilter
        GENERATOR_ARGS
        GENERATOR_DEPS)

_add_hannk_halide_library(
        TARGET upsample_channels_uint8
        SRCS depthwise_conv_generator.cpp
        GENERATOR_NAME UpsampleChannels
        GENERATOR_ARGS
        GENERATOR_DEPS)

add_library(op_impls INTERFACE)
target_link_libraries(op_impls INTERFACE ${_HANNK_HALIDE_TARGETS})
target_include_directories(op_impls INTERFACE $<BUILD_INTERFACE:${hannk_BINARY_DIR}>)

=== apps/hannk/interpreter/CMakeLists.txt ===

add_library(elementwise_program STATIC
            elementwise_program.cpp)
target_include_directories(elementwise_program PUBLIC $<BUILD_INTERFACE:${hannk_SOURCE_DIR}>)
target_link_libraries(elementwise_program PRIVATE Halide::Runtime)

add_library(interpreter_lower STATIC
            lower.cpp)
target_include_directories(interpreter_lower PUBLIC $<BUILD_INTERFACE:${hannk_SOURCE_DIR}>)
target_link_libraries(interpreter_lower PRIVATE Halide::Runtime)

add_library(interpreter STATIC
            allocation_planner.cpp
            interpreter.cpp
            interval.cpp
            model.cpp
            ops.cpp
            tensor.cpp
            transforms.cpp)
target_include_directories(interpreter PUBLIC $<BUILD_INTERFACE:${hannk_SOURCE_DIR}>)
target_link_libraries(interpreter PRIVATE elementwise_program op_impls interpreter_lower Halide::Runtime)

foreach (LIB IN ITEMS
            elementwise_program
            interpreter_lower
            interpreter)
    target_compile_options(${LIB}
                           PRIVATE
                           $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-Woverloaded-virtual>
                           $<$<CXX_COMPILER_ID:GNU>:-Wsuggest-override>
                           $<$<CXX_COMPILER_ID:Clang,AppleClang>:-Winconsistent-missing-destructor-override>
                           $<$<CXX_COMPILER_ID:Clang,AppleClang>:-Winconsistent-missing-override>)
endforeach ()

=== debian/changelog ===
halide (13.0.3-2) unstable; urgency=medium

  * Declare missing Breaks+Replaces on halide13-api-doc. Fixes #1003424.
  * Drop liblld dependency - only needed for WebAssembly,
    but we don't build that anyway.
  * Don't enable LLD/PGO on some more architectures where that fails.
  * Fine-tune some more missing dependencies.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Mon, 10 Jan 2022 12:15:10 +0300

halide (13.0.3-1) unstable; urgency=medium

  * Update to latest upstream release, refresh patches.
  * Package Python3 bindings.
    Thanks goes to Mark Glines for bringing this up initially.
  * Split Doxygen API docs into their own package, separate from C++ tutorials.
  * Package Python3 tutorials.
  * Yet another RISC-V build fix.
  * Don't hard-require libomp, it isn't strictly needed.
  * Explicitly overrule DEB_BUILD_MAINT_OPTIONS's request to do LTO,
    since we do our own LTO handling. Might fix Ubuntu build.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Thu, 06 Jan 2022 15:14:53 +0300

halide (13.0.2-2) unstable; urgency=medium

  * Another RISC-V build fix
  * Instruct CTest to rerun failed tests a few times to weed out
    intermitten test failures
  * Rebuild to pacify intermitten test failures

 -- Roman Lebedev <lebedev.ri@gmail.com>  Sun, 19 Dec 2021 13:33:16 +0300

=== debian/control ===
Source: halide
Section: devel
Priority: optional
Maintainer: Roman Lebedev <lebedev.ri@gmail.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3,
               python3-dev,
               libpython3-dev,
               pybind11-dev,
               python3-numpy,
               python3-imageio,
               cmake,
               ninja-build,
               llvm-13,
               llvm-13-dev,
               clang-13,
               libclang-13-dev,
               lld-13 [!powerpc !mips64el !ppc64 !riscv64],
               libomp-13-dev [!armel !mipsel !s390x !sparc64 !x32],
               libgl-dev,
               zlib1g-dev,
               libjpeg-dev,
               libpng-dev,
               doxygen,
               libxml2-dev,
               libopenblas-dev   [!armel !mipsel !x32],
               libatlas-base-dev [ armel  mipsel  ]
Standards-Version: 4.6.0
Homepage: https://halide-lang.org/
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/halide/-/tree/debian
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/halide.git -b debian
Rules-Requires-Root: no

Package: libhalide13-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast, portable computation on images and tensors
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 Halide currently targets:
  * CPU architectures: X86, ARM, MIPS, Hexagon, PowerPC, RISC-V
  * Operating systems: Linux, Windows, macOS, Android, iOS, Qualcomm QuRT
  * GPU Compute APIs: CUDA, OpenCL, OpenGL Compute Shaders, Apple Metal,
                     Microsoft Direct X 12
 Rather than being a standalone programming language,
 Halide is embedded in C++. This means you write C++ code that builds
 an in-memory representation of a Halide pipeline using Halide's C++ API.
 You can then compile this representation to an object file,
 or JIT-compile it and run it in the same process.

Package: libhalideaot13-0
Architecture: all
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends},
         libllvm13
Description: fast, portable computation on images and tensors (virtual library)
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 Software that uses halide can either rely on just-in-time compilation,
 in which case it runtime-depends on/links to libhalide, or it can be compiled
 ahead of time, when building the software, in which case it does not strictly
 depend on halide. Former software should depend on this package instead, to
 make it obvious which software needs to be rebuilt with newer halide versions.
 .
 This is an empty package.

Package: libhalide13-0-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libhalide13-0 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends},
         llvm-13-dev
Suggests: libhalide13-doc, halide13-api-doc
Description: fast, portable computation on images and tensors -- Development files
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 This package contains the files necessary to develop against libhalide.

Package: libhalide13-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: libhalide13-0-dev
Description: fast, portable computation on images and tensors (C++ documentation)
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 This package contains README's and tutorials for using Halide from C++.

Package: halide13-api-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: libhalide13-0-dev
Breaks:   libhalide13-doc (<< 13.0.3)
Replaces: libhalide13-doc (<< 13.0.3)
Description: fast, portable computation on images and tensors (Doxygen documentation)
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 This package contains Doxygen-generated API documentation.

Package: python3-halide
Architecture: any
Multi-Arch: same
Section: python
Depends: libhalide13-0 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends},
         ${python3:Depends}
Suggests: python3-halide-doc
Description: fast, portable computation on images and tensors -- Python3 bindings
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 This package contains provides a Python binding that provides full support
 for writing Halide embedded in Python without C++.

Package: python3-halide-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: python3-halide
Description: fast, portable computation on images and tensors (Python3 documentation)
 Halide is a programming language designed to make it easier to write
 high-performance image and array processing code on modern machines.
 .
 This package contains tutorials for writing Halide embedded in Python.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# We do not care about distro's LTO preferences.
DEB_BUILD_MAINT_OPTIONS += optimize=-lto

HALIDE_VERSION = 13

HALIDE_SOVERSION = 0

LLVM_VERSION = 13

WITH_LTO = ON
WITH_TESTS = ON
WITH_PGO = ON
WITH_LLD = ON

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Respect nocheck.
	WITH_TESTS = OFF
	# If we aren't allowed to run tests, then certainly no PGO either.
	WITH_PGO = OFF
endif


ifeq ($(DEB_HOST_ARCH),powerpc)
	# No LLD.
	WITH_LLD = OFF
endif

ifeq ($(DEB_HOST_ARCH),mips64el)
	# LLD does not seem to work out-of-the box.
	WITH_LLD = OFF
	# LLVMgold.so not found, don't bother for now.
	WITH_PGO = OFF
endif

ifeq ($(DEB_HOST_ARCH),s390x)
	# LLD does not seem to work out-of-the box.
	WITH_LLD = OFF
	# Don't bother for now.
	WITH_PGO = OFF
endif

ifeq ($(DEB_HOST_ARCH),sparc64)
	# LLD does not seem to work out-of-the box.
	WITH_LLD = OFF
	# Don't bother for now.
	WITH_PGO = OFF
endif

ifeq ($(DEB_HOST_ARCH),ppc64)
	# LLD does not seem to work out-of-the box.
	WITH_LLD = OFF
endif

ifeq ($(DEB_HOST_ARCH),riscv64)
	# Linker relaxation is not implemented, need to compile with -mno-relax,
	# but then can't link to libs that aren't compiled with -mno-relax.
	WITH_LLD = OFF
	# Constrained builders, let's not bother with LTO for now.
	WITH_LTO = OFF
	# There is no LLVM compiler-rt library on riscv64, so PGO is impossible.
	WITH_PGO = OFF
endif

CC = clang-$(LLVM_VERSION)
CXX = clang++-$(LLVM_VERSION)

SOURCE_DIR = $(CURDIR)

BUILD_STAGE ?= 1
STAGE_COMPILE_FLAGS ?=

CFLAGS = -g $(STAGE_COMPILE_FLAGS)

ifneq ($(WITH_LLD),OFF)
	CFLAGS += -fuse-ld=lld-$(LLVM_VERSION)
endif

CXXFLAGS = $(CFLAGS)

PROFILE_DIR = $(SOURCE_DIR)/build-profile
PROFILE_TMP_DIR = $(PROFILE_DIR)/raw
LLVM_PROFILE_FILE = "$(PROFILE_TMP_DIR)/stage-$(BUILD_STAGE)-%p-%m.profraw"
PROFILE = $(PROFILE_DIR)/default.profdata

BUILD_DIR_PREFIX = $(SOURCE_DIR)/build

STAGE_BUILD_DIR_PREFIX = $(BUILD_DIR_PREFIX)/stage-$(BUILD_STAGE)
BUILD_DIR = $(STAGE_BUILD_DIR_PREFIX)/halide
INSTALL_DIR = $(STAGE_BUILD_DIR_PREFIX)/halide-install
APPS_BUILD_DIR = $(STAGE_BUILD_DIR_PREFIX)/halide-test-apps

# Certain halide tests are sensitive to system load, and may be flaky.
TEST_GROUPS_FLAKY = performance|auto_schedule

%:
	dh $@ --with python3 --buildsystem=cmake+ninja

perform_stage_build:
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_configure --sourcedir=$(SOURCE_DIR) --builddir=$(BUILD_DIR) -- \
	-DCMAKE_C_COMPILER=$(CC) \
	-DCMAKE_CXX_COMPILER=$(CXX) \
	-DCMAKE_C_FLAGS="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=$(WITH_LTO) \
	-DCMAKE_POSITION_INDEPENDENT_CODE=ON \
	-DHalide_ENABLE_RTTI=ON \
	-DHalide_ENABLE_EXCEPTIONS=ON \
	-DWITH_PYTHON_BINDINGS=ON \
	-DHalide_REQUIRE_LLVM_VERSION=$(LLVM_VERSION) \
	-DLLVM_DIR=/usr/lib/llvm-$(LLVM_VERSION)/lib/cmake/llvm \
	-DHalide_SOVERSION_OVERRIDE=$(HALIDE_SOVERSION) \
	-DHalide_SHARED_LLVM=ON \
	-DTARGET_WEBASSEMBLY=OFF \
	-DWITH_TESTS=$(WITH_TESTS) \
	-DWITH_TEST_PYTHON=$(WITH_TESTS) \
	-DWITH_DOCS=ON \
	-DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)/ \
	-DHalide_INSTALL_PLUGINDIR=lib/$(DEB_HOST_MULTIARCH)/halide$(HALIDE_VERSION)/ \
	-DCMAKE_INSTALL_INCLUDEDIR=include/halide$(HALIDE_VERSION)/ \
	-DHalide_INSTALL_CMAKEDIR=lib/$(DEB_HOST_MULTIARCH)/cmake/Halide$(HALIDE_VERSION)/ \
	-DHalide_INSTALL_HELPERSDIR=lib/$(DEB_HOST_MULTIARCH)/cmake/HalideHelpers$(HALIDE_VERSION)/ \
	-DCMAKE_INSTALL_BINDIR=lib/$(DEB_HOST_MULTIARCH)/halide$(HALIDE_VERSION)/ \
	-DHalide_INSTALL_TOOLSDIR=src/halide$(HALIDE_VERSION)/ \
	-DHalide_INSTALL_PYTHONDIR=lib/python3/dist-packages/ \
	-DCMAKE_INSTALL_DOCDIR=share/doc/halide$(HALIDE_VERSION)/

	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_build --builddir=$(BUILD_DIR)

	# Remove files that won't be needed anymore.
	# This reduces the total amount of disk space used during build.
	find $(BUILD_DIR) \( -name '*.o' -or -name '*.a' \) -delete

ifneq ($(WITH_TESTS),OFF)
	# WARNING: running multiple halide tests in parallel is unsupported!
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) ctest -j1 --exclude-regex "$(TEST_GROUPS_FLAKY)"                       --output-on-failure --test-dir $(BUILD_DIR)
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) ctest -j1 --label-regex   "$(TEST_GROUPS_FLAKY)" --repeat until-pass:5 --output-on-failure --test-dir $(BUILD_DIR)
endif

	dh_auto_install --builddir=$(BUILD_DIR) --destdir=$(INSTALL_DIR)

	# Remove the whole build directory. We no longer need it.
	rm -rf $(BUILD_DIR)

ifneq ($(WITH_TESTS),OFF)
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_configure --sourcedir=$(SOURCE_DIR)/apps/ --builddir=$(APPS_BUILD_DIR) -- \
	-DCMAKE_C_COMPILER=$(CC) -DCMAKE_CXX_COMPILER=$(CXX) \
	-DCMAKE_C_FLAGS="$(CFLAGS)" -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release -DCMAKE_INTERPROCEDURAL_OPTIMIZATION=$(WITH_LTO) \
	-DENABLE_APPS_HANNK=OFF \
	-DHalide_DIR=$(INSTALL_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Halide$(HALIDE_VERSION)/ \
	-DHalideHelpers_DIR=$(INSTALL_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/HalideHelpers$(HALIDE_VERSION)/

	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) dh_auto_build --builddir=$(APPS_BUILD_DIR)

	# Remove files that won't be needed anymore.
	# This reduces the total amount of disk space used during build.
	find $(APPS_BUILD_DIR) \( -name '*.o' -or -name '*.a' \) -delete

	# WARNING: running multiple halide tests in parallel is unsupported!
	LLVM_PROFILE_FILE=$(LLVM_PROFILE_FILE) ctest -j1 --output-on-failure --test-dir $(APPS_BUILD_DIR)

	# Remove the whole build directory. We no longer need it.
	rm -rf $(APPS_BUILD_DIR)
endif

override_dh_auto_configure:
	# Nothing to do. Because of multi-stage build, everything happens in override_dh_auto_build.

override_dh_auto_build:
ifneq ($(WITH_PGO),OFF)
	BUILD_STAGE=0 STAGE_COMPILE_FLAGS="-fprofile-generate -Xclang -mllvm -Xclang -vp-counters-per-site=2.0" $(MAKE) -f debian/rules perform_stage_build
	rm -rf $(BUILD_DIR_PREFIX)
	llvm-profdata-$(LLVM_VERSION) merge -output=$(PROFILE) $(PROFILE_TMP_DIR)
	rm -rf $(PROFILE_TMP_DIR)

	# FIXME: why doesn't this work?
	# BUILD_STAGE=<placeholder> STAGE_COMPILE_FLAGS="-fprofile-use=$(PROFILE) -fcs-profile-generate -Xclang -mllvm -Xclang -vp-counters-per-site=15.0" $(MAKE) -f debian/rules perform_stage_build
	# rm -rf $(BUILD_DIR_PREFIX)
	# rm $(PROFILE)
	# llvm-profdata-$(LLVM_VERSION) merge -output=$(PROFILE) $(PROFILE_TMP_DIR)
	# FIXME: should we merge the non-CS profile with CS profile? how?
	# rm -rf $(PROFILE_TMP_DIR)

	STAGE_COMPILE_FLAGS="-fprofile-use=$(PROFILE)" $(MAKE) -f debian/rules perform_stage_build
else
	$(MAKE) -f debian/rules perform_stage_build
endif

override_dh_auto_test:
	# Nothing to do. Because of multi-stage build, everything happens in override_dh_auto_build.

override_dh_auto_install:
	# Nothing to do. Because of multi-stage build, everything happens in override_dh_auto_build.

override_dh_install:
	dh_install --sourcedir=$(INSTALL_DIR)
